import Support as sp
import numpy as np

def get_level4Instances(conn):
    lv4_instances = np.array([],dtype= int)
    cur = conn.cursor()
    query = "select distinct m.level4_instance from machining m join logEntries log on (log.timestamp=m.level4_timestamp and log.activity = m.level4_activity and log.step_id=m.level4_step_id and log.instance=m.level4_instance) order by m.level4_instance"
    #print(query)
    cur.execute(query)
    sqlResult=cur.fetchall()
    for entry in sqlResult:
        lv4_instance = np.array(int(entry[0]), dtype = lv4_instances.dtype)
        lv4_instances=np.append(lv4_instances,lv4_instance)
    #print("LV4")
    #print(lv4_instances)
    return lv4_instances



def orderLV4InstancesChronoligically(lv4_instances, conn):
    cur = conn.cursor()
    liststring = sp.list_to_string(lv4_instances)
    query = "select distinct m.level4_instance from machining m join logEntries log on (log.timestamp=m.level4_timestamp and log.activity = m.level4_activity and log.step_id=m.level4_step_id and log.instance=m.level4_instance) where level4_instance in (" + liststring + ") order by m.timestamp asc"
    #print(query)
    cur.execute(query)
    sqlResult=cur.fetchall()
    #print(sqlResult)
    lv4_instances = np.array([], dtype = int)
    for entry in sqlResult:
        lv4_instances = np.append(lv4_instances, np.array([int(entry[0])], dtype = lv4_instances.dtype))
    #print("LV4Sorted")
    #print(lv4_instances)
    return lv4_instances